package com.zipcodewilmington.generic.group;

import com.zipcodewilmington.generic.identifiables.IdentifiableInterface;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * @author leon on 06/12/2018.
 */
public class Group<TypeOfId extends Serializable,TypeOfEntity extends IdentifiableInterface<TypeOfId>>
        extends AbstractGroup<TypeOfId, TypeOfEntity>{
    private List<TypeOfEntity> group = new ArrayList<>();

    @Override
    public Integer count() {
        return group.size();
    }

    @Override
    public void insert(TypeOfEntity object) {
        group.add(object);
    }

    @Override
    public void delete(TypeOfEntity object) {
        group.remove(object);

    }

    @Override
    public void delete(TypeOfId serializable) {
        group.remove(serializable);
    }

    @Override
    public Boolean has(TypeOfEntity object) {
        return group.contains(object);
    }

    @Override
    public Boolean has(TypeOfId serializable) {
        return group.contains(serializable);
    }

    @Override
    public List filter(Predicate<TypeOfEntity> predicate) {

        return group.stream()
                .filter(predicate)
                .collect(Collectors.toList());
    }
}
